<template>
	<div class="ApiKeys">
		<div class="d-flex justify-space-between align-center">
			<h3>API Keys</h3>
			<api-key-create-button class="mb-2" color="primary" />
		</div>

		<v-card>
			<v-data-table
				:headers="headers"
				:items="apiKeys"
				:search="search"
				:footer-props="{
					'items-per-page-options': [10],
				}"
				:mobile-breakpoint="-1"
				:disable-pagination="apiKeys.length <= 10"
				:hide-default-footer="apiKeys.length <= 10"
				hide-default-header
				multi-sort
				no-data-text="No API keys found."
			>
				<template v-if="apiKeys.length > 10" v-slot:top>
					<v-text-field
						v-model="search"
						append-icon="mdi-magnify"
						label="Search API keys..."
						single-line
						hide-details
					/>
				</template>
				<template slot="item.actions" slot-scope="props">
					<api-key-revoke-button :apiKey="props.item" />
				</template>
			</v-data-table>
		</v-card>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import { DataTableHeader } from 'vuetify';
import { ApiKey } from '../../store/types';
import ApiKeyCreateButton from './ApiKeyCreateButton.vue';
import ApiKeyRevokeButton from './ApiKeyRevokeButton.vue';

export default defineComponent({
	components: {
		ApiKeyCreateButton,
		ApiKeyRevokeButton,
	},
	props: {
		apiKeys: {
			type: Array as () => Array<ApiKey>,
			required: true,
		},
	},
	setup() {
		const search = ref<string>('');

		const headers: DataTableHeader[] = [
			{ text: 'Label', value: 'label' },
			{ text: '', value: 'actions', sortable: false, align: 'end' },
		];

		return {
			headers,
			search,
		};
	},
});
</script>
